C...wx2cbx.f is a part of the VINCIA event generator.
C...This file was generated by MADGRAPH
C...Modified by VINCIA Tue Jul 31 16:36:19 CEST 2012
C...VINCIA is licenced under the GNU GPL version 2.
C...Copyright (C) 2012 Peter Skands
C...Please respect the work of the MadGraph authors by citing MadGraph when
C...this part of VINCIA is used.
 
C...VINCIA: Include helicity information
      SUBROUTINE Swx2cbx(MCMODE,P1,HEL1,ANS)
C  
C Generated by MadGraph II                                              
C MadGraph StandAlone Version
C RETURNS AMPLITUDE SQUARED SUMMED/AVG OVER COLORS
C AND HELICITIES
C FOR THE POINT IN PHASE SPACE P(0:3,NEXTERNAL)
C  
C FOR PROCESS : w+ -> c b~  
C  
C Crossing   1 is w+ c~ -> b~  
      IMPLICIT NONE
C  
C CONSTANTS
C  
      integer    nexternal, MCMODE
      parameter (nexternal=  3)
      integer    nincoming
      parameter (nincoming=  1)
      INTEGER                 NCOMB,     NCROSS         
      PARAMETER (             NCOMB=  12, NCROSS=  1)
      INTEGER    THEL
      PARAMETER (THEL=NCOMB*NCROSS)
C  
C ARGUMENTS 
C  
C...VINCIA: Define HEL1 variable
      INTEGER HEL1(3)
      DOUBLE PRECISION P1(0:3,NEXTERNAL),ANS(NCROSS)
C  
C LOCAL VARIABLES 
C  
      INTEGER NHEL(NEXTERNAL,NCOMB),NTRY
      DOUBLE PRECISION T, P(0:3,NEXTERNAL)
      DOUBLE PRECISION wx2cbx
      INTEGER IHEL,IDEN(NCROSS),IC(NEXTERNAL,NCROSS)
      INTEGER IPROC,JC(NEXTERNAL), I
      LOGICAL GOODHEL(NCOMB,NCROSS)
C      DATA NTRY/0/
C      DATA GOODHEL/THEL*.FALSE./
      NTRY=0
      DO IPROC=1,NCROSS
         DO IHEL=1,NCOMB
            GOODHEL(IHEL,IPROC)=.FALSE.
         ENDDO
      ENDDO
      DATA (NHEL(IHEL,   1),IHEL=1, 3) /-1,-1,-1/
      DATA (NHEL(IHEL,   2),IHEL=1, 3) /-1,-1, 1/
      DATA (NHEL(IHEL,   3),IHEL=1, 3) /-1, 1,-1/
      DATA (NHEL(IHEL,   4),IHEL=1, 3) /-1, 1, 1/
      DATA (NHEL(IHEL,   5),IHEL=1, 3) / 0,-1,-1/
      DATA (NHEL(IHEL,   6),IHEL=1, 3) / 0,-1, 1/
      DATA (NHEL(IHEL,   7),IHEL=1, 3) / 0, 1,-1/
      DATA (NHEL(IHEL,   8),IHEL=1, 3) / 0, 1, 1/
      DATA (NHEL(IHEL,   9),IHEL=1, 3) / 1,-1,-1/
      DATA (NHEL(IHEL,  10),IHEL=1, 3) / 1,-1, 1/
      DATA (NHEL(IHEL,  11),IHEL=1, 3) / 1, 1,-1/
      DATA (NHEL(IHEL,  12),IHEL=1, 3) / 1, 1, 1/
      DATA (  IC(IHEL,  1),IHEL=1, 3) / 1, 2, 3/
      DATA (IDEN(IHEL),IHEL=  1,  1) /   3/
C ----------
C BEGIN CODE
C ----------
      NTRY=NTRY+1
      DO IPROC=1,NCROSS
C...VINCIA: If spin-dependent, set GOODHEL for helicities of interest
C...VINCIA: First, unpolarized Z/W
      IF (HEL1(1) .GT. 0 .AND. HEL1(2) .GT. 0) THEN
         GOODHEL(HEL1(1),IPROC)=.TRUE.
         GOODHEL(HEL1(2),IPROC)=.TRUE.
         GOODHEL(HEL1(3),IPROC)=.TRUE.
      ENDIF
C...VINCIA: Now, polarized Z/W
      IF (HEL1(1) .GT. 0 .AND. HEL1(2) .LT. 0) THEN
         GOODHEL(HEL1(1),IPROC)=.TRUE.
      ENDIF
      CALL mowx2cbx(P1,P,IC(1,IPROC),JC,NEXTERNAL)
      DO IHEL=1,NEXTERNAL
         JC(IHEL) = +1
      ENDDO
      ANS(IPROC) = 0D0
          DO IHEL=1,NCOMB
C...VINCIA: If spin-dependent, only compute amplitudes with true GOODHEL
             IF (HEL1(1) .GT. 0) THEN
                IF (GOODHEL(IHEL,IPROC)) THEN
                    T=wx2cbx(MCMODE,P,NHEL(1,IHEL),JC(1))
                     ANS(IPROC) = ANS(IPROC)+T
                ENDIF
             ENDIF
C...VINCIA: If spin-summed, sum all helicity amplitudes
             IF (HEL1(1) .LT. 0) THEN               
               IF (GOODHEL(IHEL,IPROC) .OR. NTRY .LT. 2) THEN
                 T=wx2cbx(MCMODE,P ,NHEL(1,IHEL),JC(1))            
                 ANS(IPROC) = ANS(IPROC)+T
                 IF (T .NE. 0D0 .AND. .NOT. GOODHEL(IHEL,IPROC)) THEN
                   GOODHEL(IHEL,IPROC)=.TRUE.
                 ENDIF
               ENDIF
             ENDIF
          ENDDO

C...VINCIA: Do not include spin average and Bose factor
C      ANS(IPROC)=ANS(IPROC)/DBLE(IDEN(IPROC))
      ENDDO
      END
       
       
      DOUBLE PRECISION FUNCTION wx2cbx(MCMODE,P,NHEL,IC)
C  
C Generated by MadGraph II                                              
C RETURNS AMPLITUDE SQUARED SUMMED/AVG OVER COLORS
C FOR THE POINT WITH EXTERNAL LINES W(0:6,NEXTERNAL)
C  
C FOR PROCESS : w+ -> c b~  
C  
      IMPLICIT NONE
C  
C CONSTANTS
C  
      INTEGER    NGRAPHS,    NEIGEN 
      PARAMETER (NGRAPHS=   1,NEIGEN=  1) 
      integer    nexternal, MCMODE
      parameter (nexternal=  3)
      integer    nincoming
      parameter (nincoming=  1)
      INTEGER    NWAVEFUNCS     , NCOLOR
      PARAMETER (NWAVEFUNCS=   3, NCOLOR=   1) 
      DOUBLE PRECISION     ZERO
      PARAMETER (ZERO=0D0)
      DOUBLE PRECISION ZLCSUM, FSLC
C  
C ARGUMENTS 
C  
      DOUBLE PRECISION P(0:3,NEXTERNAL)
      INTEGER NHEL(NEXTERNAL), IC(NEXTERNAL)
C  
C LOCAL VARIABLES 
C  
      INTEGER I,J
      COMPLEX*16 ZTEMP
      DOUBLE PRECISION DENOM(NCOLOR), CF(NCOLOR,NCOLOR)
      COMPLEX*16 AMP(NGRAPHS), JAMP(NCOLOR)
      COMPLEX*16 W(18,NWAVEFUNCS)
C  
C GLOBAL VARIABLES
C  
      include "coupl.inc"
C  
C COLOR DATA
C  
      DATA Denom(1  )/            1/                                       
      DATA (CF(i,1  ),i=1  ,1  ) /     3/                                  
C               T[ 2, 3]                                                   
C ----------
C BEGIN CODE
C ----------
      CALL VXXXXX(P(0,1   ),WMASS ,NHEL(1   ),-1*IC(1   ),W(1,1   ))       
      CALL OXXXXX(P(0,2   ),ZERO ,NHEL(2   ),+1*IC(2   ),W(1,2   ))        
      CALL IXXXXX(P(0,3   ),BMASS ,NHEL(3   ),-1*IC(3   ),W(1,3   ))       
      CALL IOVXXX(W(1,3   ),W(1,2   ),W(1,1   ),GWFCB ,AMP(1   ))          
      JAMP(   1) = -AMP(   1)
C...VINCIA: Leading Color
      wx2cbx = CF(1,1)*JAMP(1)*DCONJG(JAMP(1))/DENOM(1)
C...VINCIA: Absorb subleading color proportional to FSLC = LC/Sum(LC)
      IF (wx2cbx.GT.ZERO.AND.MCMODE.GE.1) THEN
        ZLCSUM = wx2cbx
C        DO I = 2, NCOLOR
C          ZLCSUM = ZLCSUM + CF(I,I)*JAMP(I)*DCONJG(JAMP(I))/DENOM(I)
C        ENDDO
C...VINCIA: Fraction of subleading color to absorb into this permutation
        FSLC = wx2cbx/ZLCSUM
C...VINCIA: Sum over subleading contributions multiplied by FSLC 
      DO I = 1, NCOLOR
          ZTEMP = (0.D0,0.D0)
          DO J = 1, NCOLOR
              IF (I.NE.J) ZTEMP = ZTEMP + CF(J,I)*JAMP(J)
          ENDDO
          wx2cbx =wx2cbx+FSLC*ZTEMP*DCONJG(JAMP(I))/DENOM(I)   
      ENDDO
      ENDIF
C      CALL GAUGECHECK(JAMP,ZTEMP,EIGEN_VEC,EIGEN_VAL,NCOLOR,NEIGEN) 
      END
       
       
      subroutine mowx2cbx(p1,p,ic,jc,nexternal)
      implicit none
      integer nexternal
      integer jc(nexternal),ic(nexternal)
      real*8 p1(0:3,nexternal),p(0:3,nexternal)
      integer i,j
      do i=1,nexternal
         do j=0,3
            p(j,ic(i))=p1(j,i)
         enddo
      enddo
      do i=1,nexternal
         jc(i)=1
      enddo
      jc(ic(1))=-1
      jc(ic(2))=-1
      end
