// PythiaRoot.h is a part of the VINCIA plug-in to the PYTHIA 8 generator.
// Copyright (C) 2013 P. Skands
// VINCIA is licenced under the GNU GPL version 2.
// Please respect the MCnet Guidelines for Event Generator Authors and Users, 
//               http://www.montecarlonet.org/GUIDELINES

// This file contains utilities for translating between PYTHIA and ROOT
// histograms

#ifndef PYTHIAROOT_H
#define PYTHIAROOT_H

// Include the Pythia Histogram and VinciaRoot Settings headers 
// (ROOT and STDLIB headers included in VinciaSettings.h)

#include "Pythia8/Basics.h"
#include "VRsettings.h"

// Put all the rest in Vincia namespace

namespace Vincia {
  
  //***********************************************************************  
  void Hist2TH1(TH1* th1Ptr, Hist* histPtr) {
    for (int iBin = 0; iBin <= th1Ptr->GetNbinsX() + 1; ++iBin) {
      double cont = histPtr->getBinContent(iBin);
      th1Ptr->SetBinContent(iBin,cont);
    }
  }
  
}

#endif
